
//test for Serial COM with matlab

#define F_CPU 16000000UL
#include <inttypes.h>
#include <avr/io.h>
#include <avr/interrupt.h>
#include <stdio.h>
#include <math.h>
#include <util/delay.h>
// serial communication library
#include "uart.h"
#include "uart.c"

	double counter;

// UART file descriptor
// putchar and getchar are in uart.c
FILE uart_str = FDEV_SETUP_STREAM(uart_putchar, uart_getchar, _FDEV_SETUP_RW);


void delay (void);
void initialize(void);

int main(void)
{
	int move;	
  // 0 - left, 1- right, 2- straight, 3 - stop
	initialize();

	while(1){
	     fscanf(stdin,"%d",&move); // receive data
		 switch (move)
		 {
		 	case 0:	 
				PORTA = 0x01; // move left
			    _delay_ms (1000); 
				break;
			
			case 1:
		 	
				PORTA = 0x04; // move right
			    _delay_ms (1000); 
				break;
			
			case 2:
			
				PORTA = 0x05; // move straight
			    _delay_ms (1000); 
				break;
            
			case 3:
			
				PORTA = 0x00; // halt
			    _delay_ms (1000); 
				break;

			default: 
				PORTA = 0x00; // halt
			    _delay_ms (1000); 
				break;

		   }
}

}

void initialize(void)
{
  DDRA =0xFF;      

  //init the UART -- uart_init() is in uart.c
  uart_init();
  stdout = stdin = stderr = &uart_str;

 fprintf(stdout,"Starting...\n\r");
  
}  

